import "@paperclover/console/inject";
import "#debug";

const app = require(globalThis.CLOVER_SERVER_ENTRY ?? process.argv[2]);

const protocol = "http";

const server = serve({
  fetch: app.fetch,
  port: Number(process.env.PORT ?? 3000),
}, ({ address, port }) => {
  if (address === "::") address = "::1";
  console.info(url.format({
    protocol,
    hostname: address,
    port,
  }));
});

process.on("SIGINT", () => {
  server.close();
  process.exit(0);
});

process.on("SIGTERM", () => {
  server.close((err) => {
    if (err) {
      console.error(err);
      process.exit(1);
    }
    process.exit(0);
  });
});

declare global {
  /* Control via --define:globalThis.CLOVER_SERVER_ENTRY="..." */
  var CLOVER_SERVER_ENTRY: string;
}

import url from "node:url";
import { serve } from "@hono/node-server";
import process from "node:process";
